题目描述
输入一个数组和一个数字 s,在数组中查找两个数,使得它们的和正好是 s。
如果有多对数字的和等于 s,输出任意一对即可。
你可以认为每组输入中都至少含有一组满足条件的输出。
数据范围
数组长度 [1,1002]。
样例
输入:[1,2,3,4] , sum=7 输出:[3,4]
方法一:哈希表 O(n)
这道题可以用哈希表来存储每个数 x ,这样可以在遍历每个数的过程中先判断遍历的这个数是否能在哈希表中存在 target 与 x 的差值,如果存在则说明有着一对数。
比如,数组为 [1,2,3,4] ,且 target = 7 。那么当遍历到 4 的时候,哈希表中已经存有 1,2,3 ,这时候去查找 target 与 4 的差值即 target - 4 = 7 - 4 = 3 ,发现 3 已经在哈希表中,故存在这么一对数满足两者相加等于 target 。
class Solution { public: vector<int> findNumbersWithSum(vector<int>& nums, int target) { unordered_map<int, int> hash; for (auto x : nums) { if (hash.count(target - x)) return{ x,target - x }; hash[x] = 1; } return {}; } };
方法二:双指针 O(n)
我们也可以用两个指针 i 和 j 来进行判断,再遍历之前要先将数组从小到大进行排序,然后 i 从第一元素往后扫描,而 j 从最后一个元素往前扫描。
遍历过程中的每一趟都去比较一下 i 和 j 指向两个元素的和与 target 的大小,如果和要大于 target ,则需要 j 往前移一位,因为 i 之后的元素只会更大而 j 之前的元素会更小,可以尝试将和减小到 target 及其附近。反之,如果和要小于 target ,则需要 i 往后移一位,使和能够等于或接近 target 。
我们来看一个例子,假设有一个数组 [1,3,3,4] ,且 target = 6 。
第一步: sum = nums[i] + nums[j] = 1 + 4 = 5 < 6 ,故 i 往后移一位。
第二步:sum = nums[i] + nums[j] = 3 + 4 = 5 > 7
,故 j
往前移一位。
第三步:sum = nums[i] + nums[j] = 3 + 3 = 6 == 6
,故得到和为 target
的两个数字 3
和 3
。
class Solution { public: vector<int> findNumbersWithSum(vector<int>& nums, int target) { sort(nums.begin(), nums.end()); int i = 0, j = nums.size() - 1; while (i < j) { int s = nums[i] + nums[j]; if (s < target) i++; else if (s > target) j++; else return { nums[i],nums[j] }; } return {}; } };
欢迎大家在评论区交流~